﻿Type=Activity
Version=2.00
FullScreen=False
IncludeTitle=False
@EndOfDesignText@
Sub Process_Globals
    Dim MapCenter As GeoPoint
    Dim TileSource As String
    Dim ZoomLevel As Int
    Dim GPS1 As GPS
    Dim MapTouchEnabled As Boolean
	Dim time, t1 As Timer
	Dim MainRequestId As Int
    MainRequestId = 100
	Dim Username As String
	Dim Password As String
	Username = "yakuc16"
	Password = "c424e284b07999a7b416f475c05d4134"
	Dim jsonfile As String
	jsonfile = Rnd(0, 9999999)
	Dim HttpTimer As Timer
	
    
    '    create some variables to save the MyLocationOverlay state
    Dim CompassEnabled, FollowLocationEnabled, MyLocationEnabled As Boolean
End Sub

Sub Globals
    Dim MapView1 As MapView
    Dim MinimapOverlay1 As MinimapOverlay
    Dim ScaleBarOverlay1 As ScaleBarOverlay
    Dim TouchEventGrabber As Panel
    Dim B1 As BoundingBox
    '    create the MyLocationOverlay
    Dim MyLocationOverlay1 As MyLocationOverlay
	Dim Button1, b2 As Button
	Dim httpclient1 As HttpClient
	Dim MarkersOverlay1 As MarkersOverlay
	Dim lpnl As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	time.Initialize("time", 50)
	time.Enabled = True
    Activity.AddMenuItem("Toggle FollowLocation", "MenuItemSelect")
    Activity.AddMenuItem("Toggle MapTouchEnabled", "MenuItemSelect")
	Activity.AddMenuItem("Fit map to markers", "MenuItemSelect")
    '    MapView initialized with no EventName as we'll not be listening for MapView events
    MapView1.Initialize("")
    MapView1.SetMultiTouchEnabled(True)
    MapView1.SetZoomEnabled(True)
    Activity.AddView(MapView1, 0, 0, 100%x, 100%y)
    '    initialize and add the MyLocationOverlay to the MapView, an EventName is used as we'll be listening for all three events that this overlay generates
    MyLocationOverlay1.Initialize(MapView1, "MyLocationOverlay1")
    MyLocationOverlay1.MyLocationEnabled = True
    MyLocationOverlay1.FollowLocationEnabled = True
    MapView1.AddOverlay(MyLocationOverlay1)
 
 
 	'	code moved to here
  	MarkersOverlay1.Initialize(MapView1, "MarkersOverlay1")
  	MapView1.AddOverlay(MarkersOverlay1)
 
    If FirstTime Then
		GPS1.Initialize("GPS")
        MapTouchEnabled=True
        TileSource="Mapnik"
        ZoomLevel=13
		httpclient1.Initialize("http")
        
        '    set the default values for the new variables
        CompassEnabled=MyLocationOverlay1.CompassEnabled
        FollowLocationEnabled=MyLocationOverlay1.FollowLocationEnabled
        MyLocationEnabled=MyLocationOverlay1.MyLocationEnabled
    Else
        '    restore the MyLocationOverlay state
        MyLocationOverlay1.CompassEnabled=CompassEnabled
    End If
	MapView1.Zoom=ZoomLevel
	 If GPS1.GPSEnabled = False Then
        Msgbox("For this app to work, you must enable your GPS. Press 'OK' to enable your GPS. When you have enabled your GPS, press the back button to return to the app. While your enabling your GPS also mae sure your phone's internet is on. It is needed to connect to the database and find crimes near you!", "Enable Your GPS")
        StartActivity(GPS1.LocationSettingsIntent) 'Will open the relevant settings screen.
    Else
        GPS1.Start(0, 0) 'Listen to GPS with no filters.
    End If
	MyLocationOverlay1.FollowLocationEnabled = True
    
    ScaleBarOverlay1.Initialize(MapView1)
    MapView1.AddOverlay(ScaleBarOverlay1)
    
	Dim Bmp As Bitmap
	Bmp.Initialize(File.DirAssets, "ic_dialog_info.png")

	
	    TouchEventGrabber.Initialize("TouchEventGrabber")
    If MapTouchEnabled Then
        Activity.AddView(TouchEventGrabber, 0, 0, 0, 0)
    Else
        Activity.AddView(TouchEventGrabber, 0, 0, 100%x, 89%y)
    End If
	
	MyLocationOverlay1.LocationUpdateMinDistance = 2
	Button1.Initialize("Button1")
	Activity.AddView(Button1, 100%x-35dip, 5dip, 10%x, 10%y)
	Button1.SetBackgroundImage(Bmp)
	Button1.BringToFront
	
	MyLocationOverlay1.LocationUpdateMinDistance = 0
	MyLocationOverlay1.LocationUpdateMinTime = 1
	
	lpnl.Initialize("lpnl")
	Activity.AddView(lpnl, 0,90%y, 100%x, 20%y)
	lpnl.Color = Colors.ARGB ( 100 , 0, 0, 0)
	lpnl.Text = "Loading Crimes..."
	lpnl.TextColor = Colors.White
	lpnl.BringToFront
	lpnl.Visible = False
End Sub
Sub Http_ResponseSuccess (Response As HttpResponse, TaskId As Int)
	Response.GetAsynchronously("JSONResponse" , File.OpenOutput(File.DirInternalCache, jsonfile &".json", False), True, TaskId)
End Sub
Sub JSONResponse_StreamFinish (Success As Boolean, TaskId As Int)
	'	calling RemoveMarkers will do nothing if no Markers exist
    MarkersOverlay1.RemoveMarkers
    Dim Icon As BitmapDrawable
    Icon.Initialize(LoadBitmap(File.DirAssets, "markerting.png"))
	
	Dim CrimesCount As Int
	CrimesCount = 0
	
	Dim ResponseArray As List
	ResponseArray.Initialize
	
	Dim ResponseString As String
	ResponseString=File.ReadString(File.DirInternalCache, jsonfile &".json")
	
	Dim JSON As JSONParser
	JSON.Initialize(ResponseString)
	
	ResponseArray = JSON.NextArray
	
	Dim Markers As List
	Markers.Initialize
	
	Dim CrimeObject As Map
	Dim CrimeLocationObject As Map
		
    For i = 0 To ResponseArray.Size - 1
		CrimeObject = ResponseArray.Get(i)
		CrimeLocationObject = CrimeObject.Get("location")
	    Dim Marker1 As Marker
	    Marker1.Initialize("", "", CrimeLocationObject.Get ("latitude"), CrimeLocationObject.Get ("longitude"), Icon)
	    Markers.Add(Marker1)
		CrimesCount = CrimesCount + 1
    Next
	
	MarkersOverlay1.AddMarkers(Markers)
	lpnl.Visible = False
	If CrimesCount > 0 Then
		Log(CrimesCount&" Markers created")
	Else If CrimesCount = 0 Then
		ToastMessageShow("Lucky you! There is no crime in your area!", True)
	Else
	End If
	HttpTimer.Enabled = False
	jsonfile = Rnd(0, 9999999)
End Sub
Sub b2_click

	MyLocationOverlay1.FollowLocationEnabled = True
End Sub
Sub Http_ResponseError (Reason As String, StatusCode As Int, TaskId As Int)
    ToastMessageShow("Oh No! " & Reason, True)
    ProgressDialogHide
End Sub
Sub Activity_Resume
	GPS1.Start(0, 0)
    If GPS1.GPSEnabled = False Then
        ToastMessageShow("Please enable the GPS device.", True)
        StartActivity(GPS1.LocationSettingsIntent) 'Will open the relevant settings screen.
    Else
    End If

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed = True Then
	GPS1.Stop
    MapCenter=MapView1.GetCenter
    TileSource=MapView1.GetTileSource
    ZoomLevel=MapView1.Zoom
    
    '    save the MyLocationOverlay state
    CompassEnabled=MyLocationOverlay1.CompassEnabled
    FollowLocationEnabled=MyLocationOverlay1.FollowLocationEnabled
    MyLocationEnabled=MyLocationOverlay1.MyLocationEnabled
    
    '    disable MyLocationOverlay compass and GPS listening
    MyLocationOverlay1.CompassEnabled=False
    MyLocationOverlay1.MyLocationEnabled=False
	Else
	End If
End Sub
Sub MenuItemSelect_Click
    Dim Id As String
    Id=Sender
    Select Id
        Case "Toggle MapTouchEnabled"
            MapTouchEnabled=Not(MapTouchEnabled)
            If MapTouchEnabled Then
                TouchEventGrabber.Width=0
                TouchEventGrabber.Height=0
            Else
                TouchEventGrabber.Width=100%x
                TouchEventGrabber.Height=100%y
            End If
        Case "Toggle FollowLocation"
            MyLocationOverlay1.FollowLocationEnabled=Not(MyLocationOverlay1.FollowLocationEnabled)
    End Select
End Sub
Sub Button1_click
	StartActivity("info")
End Sub
Sub TouchEventGrabber_Touch (Action As Int, X As Float, Y As Float)
    '    do nothing
End Sub

Sub MyLocationOverlay1_LocationChanged(NewLocation As Location, IsFirstFix As Boolean)
	If IsFirstFix = True Then
	MyLocationOverlay1.LocationUpdateMinDistance = 30
	MyLocationOverlay1.LocationUpdateMinTime = 5000
	End If
	Dim request As HttpRequest
    request.InitializeGet("http://policeapi2.rkh.co.uk/api/crimes-street/all-crime?lat="& NewLocation.Latitude &"&lng="& NewLocation.Longitude &"&date=2012-04")
    lpnl.Visible = True
	httpclient1.ExecuteCredentials(request, MainRequestId, Username, Password)
	
	
End Sub
Sub time_tick
	MyLocationOverlay1.FollowLocationEnabled = True
	time.Interval = 10000
	   If GPS1.GPSEnabled = False Then
        ToastMessageShow("Please enable the GPS device.", True)
        StartActivity(GPS1.LocationSettingsIntent) 'Will open the relevant settings screen.
    Else
    End If
End Sub
